<?php
/*
Plugin Name: Google CSE for WP
Plugin URI: http://vrypan.net/log/
Description: Create a Google Custom Search Engine using your blogroll and blog.
Version: 0.1
Author: Panayotis Vryonis
Author URI: http://vrypan.net/

This is Open Source Software.
This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License
(GPL) as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later                                                                                                           
version.
*/

function cse_gen_main() {
	$out = '<?xml version="1.0" encoding="UTF-8" ?>
<GoogleCustomizations>
	<CustomSearchEngine>
		<Title>WP Search</Title>
		<Description>A Google Custom Search Engine that only includes my links and feeds</Description>
		<Context>
			<BackgroundLabels>
				<Label name="wp_cse" mode="FILTER"/>
			</BackgroundLabels>
		</Context>
	</CustomSearchEngine>
        <Include type="Annotations" href="' . get_settings('siteurl') . '/wp-content/plugins/google_cse/blogroll.xml"/>
	<Annotations>
		<Annotation about="' . get_settings('siteurl') . '/*">
			<Label name="wp_cse"/>
		</Annotation>
	</Annotations>
</GoogleCustomizations>
' ;
	return $out ;
}

function cse_gen_blogroll_file() {
	global $wpdb ;
	$links = $wpdb->get_results("SELECT link_url  FROM $wpdb->links") ;

	$out .= '<GoogleCustomizations> <Annotations>' . "\n" ;
	foreach ($links as $link) {
		$l = $link->link_url ;
		if ( substr($l,-1) != '/' ) $l = $l . '/' ;
		$out .= '<Annotation about="' . $l . '*">' ;
		$out .= '<Label name="wp_cse" />' ;
		$out .= '</Annotation>' . "\n" ;
	}
	$out .= '</Annotations></GoogleCustomizations>' . "\n" ;

	return $out ;
}

function cse_write_files() {
	$home = get_settings('home');
	$home_path="";
	if ( $home != '' && $home != get_settings('siteurl') ) {
		$home_path = parse_url($home);
		$home_path = $home_path['path'];
		$root = str_replace($_SERVER["PHP_SELF"], '', str_replace("\\","/",$_SERVER["SCRIPT_FILENAME"]));
		$home_path = trailingslashit($root . $home_path);
	} else {
		$home_path = ABSPATH;
	}

	$path = $home_path . 'wp-content/plugins/google_cse/' ;


	$blogroll_file = $path . 'blogroll.xml' ;
	if ( file_exists($blogroll_file) && is_writable($blogroll_file) ) {
		$fp = fopen($blogroll_file,'w');
		fwrite($fp, cse_gen_blogroll_file() ) ;
		fclose($fp) ;
	} else {
		echo '<br/><br/>GOOGLE CSE ERROR: unable to wrtite ' . $blogroll_file . "<br/><br/>\n\n" ;
		exit ;
	}

	$cse_file = $path . 'wp_cse.xml' ;
	if ( file_exists($cse_file) && is_writable($cse_file) ) {
		$fp = fopen($cse_file,'w');
		fwrite($fp, cse_gen_main()) ;
		fclose($fp) ;
	} else {
		echo '<br/><br/>GOOGLE CSE ERROR: unable to wrtite ' . $cse_file . "<br/><br/>\n\n" ;
		exit ;
	}
}

function cse_search_box($echo = TRUE ) {
	$out = '
<!-- Google CSE Search Box Begins  -->
<!-- Use of this code assumes agreement with the Google Custom Search Terms of Service. -->
<!-- The terms of service are available at http://www.google.com/coop/docs/cse/tos.html -->
<form id="cref" action="http://google.com/cse">
  <input type="hidden" name="cref" value="' . get_settings('siteurl') . '/wp-content/plugins/google_cse/wp_cse.xml" />
  <input type="text" name="q" size="40" />
 <input type="hidden" name="client" value="pub-8379802404946155" />
  <input type="submit" name="sa" value="Search" />
</form>
<script type="text/javascript" src="http://google.com/coop/cse/brand?form=cref"></script>
<!-- Google CSE Search Box Ends -->
';
	if ($echo) 
		echo $out ;
	else 
		return $out ;
}

add_action('cse_upd_hourly','cse_write_files');
function cse_activation() { wp_schedule_event(time(), 'hourly', 'cse_upd_hourly'); }
register_activation_hook(__FILE__,'cse_activation');

?>
